﻿# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Loading Console.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}

# Execute Setup Instructions
if ($ExecutableMode -EQ "Setup") {

    # Console Configuration - Title
    $Host.UI.RawUI.WindowTitle = "Program Setup PowerShell"

    # Console Configuration - Syntax
    $Console = $Host.UI.RawUI
    $Console.ForegroundColor = "GRAY"
    $Console.BackgroundColor = "BLACK"

    # Console Configuration - Background
    $Colors = $Host.PrivateData
    $Colors.VerboseForegroundColor = "BLUE"
    $Colors.VerboseBackgroundColor = "BLACK"
    $Colors.WarningForegroundColor = "YELLOW"
    $Colors.WarningBackgroundColor = "BLACK"
    $Colors.ErrorForegroundColor = "RED"
    $Colors.ErrorBackgroundColor = "BLACK"

    # Console Configuration - Progress Bar
    $Host.PrivateData.ProgressForegroundColor = "GRAY"
    $Host.PrivateData.ProgressBackgroundColor = "BLACK"

}

# Execute Removal Instructions
if ($ExecutableMode -EQ "Remove") {

    # Console Configuration - Title
    $Host.UI.RawUI.WindowTitle = "Program Removal PowerShell"

    # Console Configuration - Syntax
    $Console = $Host.UI.RawUI
    $Console.ForegroundColor = "GRAY"
    $Console.BackgroundColor = "BLACK"

    # Console Configuration - Background
    $Colors = $Host.PrivateData
    $Colors.VerboseForegroundColor = "BLUE"
    $Colors.VerboseBackgroundColor = "BLACK"
    $Colors.WarningForegroundColor = "YELLOW"
    $Colors.WarningBackgroundColor = "BLACK"
    $Colors.ErrorForegroundColor = "RED"
    $Colors.ErrorBackgroundColor = "BLACK"

    # Console Configuration - Progress Bar
    $Host.PrivateData.ProgressForegroundColor = "GRAY"
    $Host.PrivateData.ProgressBackgroundColor = "BLACK"

}

# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Finished Console.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}