﻿# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Loading Destruct.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}

if ($DestructMode -Match "Enable") {

    # Create Environment Variables
    [Environment]::SetEnvironmentVariable("ProgramPath", [Environment]::CurrentDirectory, "Machine")
    [Environment]::SetEnvironmentVariable("ExecutionPolicy", $ExecutionPolicy, "Machine")

    # PowerShell Launcher - Mode Detection
    if ($HiddenMode -Match "Enable") {

        # PowerShell Launcher - Previous Iteration
        # $FilePath = "'$env:ProgramRoot\Files\Script Database\File.ps1'"
        # $PowerShell = "PowerShell.exe -ExecutionPolicy Bypass -WindowStyle Hidden -NoProfile -NoLogo -NonInteractive -File"
        # $CommandPrompt = "$env:SystemRoot\System32\cmd.exe /c start /min /high 'Windows Command Terminal'"
        # Invoke-Expression "$CommandPrompt $PowerShell $FilePath -Verb RunAs"

        # PowerShell Launcher - Variables
        $CommandList = {

            # PowerShell Preferences
            $ExecutableMode = "Delete"
            $ErrorActionPreference = "SilentlyContinue"
            $OutputEncoding = [Console]::InputEncoding = [Console]::OutputEncoding = New-Object System.Text.UTF8Encoding

            # Update Environment Variables
            $env:ProgramPath = [Environment]::GetEnvironmentVariable("ProgramPath", "Machine")
            $env:ExecutionPolicy = [Environment]::GetEnvironmentVariable("ExecutionPolicy", "Machine")

            # Remove Process Hooks
            [System.IO.Directory]::SetCurrentDirectory($env:UserProfile)
            Set-Location $env:UserProfile

            # Console Configuration
            $Host.UI.RawUI.WindowTitle = "Program Deletion PowerShell"

            # Terminate Process(es)
            while (Get-Process | Where-Object {($_.Description -EQ "Program Removal Launcher") -OR ($_.MainWindowTitle -EQ "Program Removal Launcher")}) {
                Get-Process | Where-Object {$_.Description -EQ "Program Removal Launcher"} | Stop-Process -Force
                Get-Process | Where-Object {$_.MainWindowTitle -EQ "Program Removal PowerShell"} | Stop-Process -Force
                Start-Sleep -Milliseconds 250
            }

            # Delete Progam Host
            Remove-Item "$env:ProgramPath" -Force -Recurse

            # Restore Execution Policy
            Set-ExecutionPolicy -ExecutionPolicy $env:ExecutionPolicy -Scope LocalMachine -Force

            # Delete Environment Variables
            [Environment]::SetEnvironmentVariable("ProgramPath", $null, "Machine")
            [Environment]::SetEnvironmentVariable("ExecutionPolicy", $null, "Machine")

            # Play Removal Sound
            $Sound = New-Object System.Media.SoundPlayer
            $Sound.SoundLocation = "$env:WinDir\Media\Windows Foreground.wav"
            $Sound.Play()

            # Prevent Sound Interrupt
            Start-Sleep -Milliseconds 2500

            # Quit PowerShell
            Stop-Process -ID $PID

        }

        # PowerShell Launcher - Hidden
        $PowerShell = "PowerShell.exe -ExecutionPolicy Bypass -WindowStyle Hidden -NoProfile -NoLogo -NonInteractive"
        $CommandPrompt = "$env:SystemRoot\System32\cmd.exe /c start /min /high 'Windows Command Terminal'"
        Invoke-Expression "$CommandPrompt $PowerShell -Command {$CommandList}"

    }

    if ($HiddenMode -Match "Disable") {

        # PowerShell Launcher - Previous Iteration
        # $FilePath = "'$env:ProgramRoot\Files\Script Database\File.ps1'"
        # $PowerShell = "PowerShell.exe -ExecutionPolicy Bypass -WindowStyle Normal -NoProfile -NoLogo -NoExit -File"
        # $CommandPrompt = "$env:SystemRoot\System32\cmd.exe /c start /high 'Windows Command Terminal'"
        # Invoke-Expression "$CommandPrompt $PowerShell $FilePath -Verb RunAs"

        # PowerShell Launcher - Variables
        $CommandList = {

            # Toggle Information
            $DebugMode = $false
            $VerboseMode = $false

            # PowerShell Preferences
            $ExecutableMode = "Delete"
            $ErrorActionPreference = "SilentlyContinue"
            $OutputEncoding = [Console]::InputEncoding = [Console]::OutputEncoding = New-Object System.Text.UTF8Encoding

            # Console Information
            if ($DebugMode -EQ $true) {
                Write-Host "Loading PowerShell"
                Write-Host "• Press [Enter] to continue."
                $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
                Write-Host ""
            }

            # Update Environment Variables
            $env:ProgramPath = [Environment]::GetEnvironmentVariable("ProgramPath", "Machine")
            $env:ExecutionPolicy = [Environment]::GetEnvironmentVariable("ExecutionPolicy", "Machine")

            # Remove Process Hooks
            [System.IO.Directory]::SetCurrentDirectory($env:UserProfile)
            Set-Location $env:UserProfile

            # Console Configuration
            $Host.UI.RawUI.WindowTitle = "Program Deletion PowerShell"

            # Terminate Process(es)
            while (Get-Process | Where-Object {($_.Description -EQ "Program Removal Launcher") -OR ($_.MainWindowTitle -EQ "Program Removal Launcher")}) {
                Get-Process | Where-Object {$_.Description -EQ "Program Removal Launcher"} | Stop-Process -Force
                Get-Process | Where-Object {$_.MainWindowTitle -EQ "Program Removal PowerShell"} | Stop-Process -Force
                Start-Sleep -Milliseconds 250
            }

            # Delete Progam Host
            Remove-Item "$env:ProgramPath" -Force -Recurse

            # Restore Execution Policy
            Set-ExecutionPolicy -ExecutionPolicy $env:ExecutionPolicy -Scope LocalMachine -Force

            # Delete Environment Variables
            [Environment]::SetEnvironmentVariable("ProgramPath", $null, "Machine")
            [Environment]::SetEnvironmentVariable("ExecutionPolicy", $null, "Machine")

            # Console Information
            if ($DebugMode -EQ $true) {
                Write-Host "Finished PowerShell"
                Write-Host "• Press [Enter] to exit."
                $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
                Write-Host ""
            }

            # Invisibility
            CLS | Out-Null

            # Play Removal Sound
            $Sound = New-Object System.Media.SoundPlayer
            $Sound.SoundLocation = "$env:WinDir\Media\Windows Foreground.wav"
            $Sound.Play()

            # Prevent Sound Interrupt
            Start-Sleep -Milliseconds 2500

            # Quit PowerShell
            Stop-Process -ID $PID

        }

        # PowerShell Launcher - Visible
        $PowerShell = "PowerShell.exe -ExecutionPolicy Bypass -WindowStyle Normal -NoProfile -NoLogo -NoExit"
        $CommandPrompt = "$env:SystemRoot\System32\cmd.exe /c start /high 'Windows Command Terminal'"
        Invoke-Expression "$CommandPrompt $PowerShell -Command {$CommandList}"

    }

    # Console Information
    if ($DebugMode -EQ $true) {
        Write-Host "Exiting Destruct.ps1"
        Write-Host "• Press [Enter] to exit."
        $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
        Write-Host ""
    }

    # Quit PowerShell
    Stop-Process -ID $PID

}

# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Finished Destruct.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}