﻿function Global:Download ($Source, $Target) {

    $URI = New-Object "System.URI" "$Source"
    $Request = [System.Net.HttpWebRequest]::Create($URI)
    $Request.Set_Timeout(15000)
    $Response = $Request.GetResponse()
    $TotalLength = [System.Math]::Floor($Response.Get_ContentLength()/1024)
    $ResponseStream = $Response.GetResponseStream()
    $TargetStream = New-Object -TypeName System.IO.FileStream -ArgumentList $Target, Create
    $Buffer = New-Object Byte[] 10KB
    $Count = $ResponseStream.Read($Buffer,0,$Buffer.Length)
    $DownloadedBytes = $Count

    while ($Count -GT 0) {

        $TargetStream.Write($Buffer, 0, $Count)
        $Count = $ResponseStream.Read($Buffer,0,$Buffer.Length)
        $DownloadedBytes = $DownloadedBytes + $Count

    }

    $TargetStream.Flush()
    $TargetStream.Close()
    $TargetStream.Dispose()
    $ResponseStream.Dispose()

}