﻿# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Loading Extension.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}

if ($ExecutableMode -EQ "Setup") {

    # Setup Registry
    if ($RegistryMode -Match "Enable") {
    
        # Modify Regisry Values [Renegade X Launcher]
        if ($FileData.Enhancements.UpdateLauncher -Match "Enable") {
            
            # Determine Internect Connection
            if (Get-NetRoute | ? DestinationPrefix -EQ '0.0.0.0/0' | Get-NetIPInterface | Where-Object ConnectionState -EQ "Connected") {
            
                # Initalise Download Function
                & "$ProgramRoot\Files\Script Database\Download.ps1"
    
                # Execute Download Function
                Download "https://static.renegade-x.com/launcher_data/version/release.json" "$ProgramRoot\Files\LauncherReleaseData.json"
                
                # Grab Launcher Version
                $LauncherVersion = (Get-Content "$ProgramRoot\Files\LauncherReleaseData.json" | ConvertFrom-Json).launcher.version_name
                
                # Delete Downloaded File
                Remove-Item "$ProgramRoot\Files\LauncherReleaseData.json" -Force
                
            }
            
            if (!(Test-Path Variable:LauncherVersion)) {
                $LauncherVersion = "0.85"
            }
            
            if (!(Test-Path "$ProgramRoot\Source\Launcher")) {
                $LauncherSize = ((Get-ChildItem "$ProgramRoot\Source\Launcher" -Recurse | Measure-Object -Property Length -Sum | Select -ExpandProperty "Sum")/1024)
            }
            
            if (!(Test-Path Variable:LauncherSize)) {
                $LauncherSize = "10580"
            }
            
        }
    
        # Delete Registry Profile [Renegade X Launcher]
        if (Test-Path "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)") {
            Remove-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Force -Recurse
        }
    
        # Install Registry Profile [Renegade X Launcher]
        New-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall" -Name "Renegade X Launcher ($env:Username)" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "DisplayName" -Value "Renegade X Launcher" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "DisplayIcon" -Value "$ProgramRoot\Files\Icon Database\Renegade X - Setup.ico" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "DisplayVersion" -Value "$LauncherVersion" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "Publisher" -Value "$env:Username" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "InstallLocation" -Value "$ProgramRoot" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "UninstallString" -Value "$env:SystemRoot\System32\cmd.exe /c start /min ""Windows Control Terminal"" /d ""$ProgramRoot"" ""$ProgramRoot\Remove.exe""" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "EstimatedSize" -Value "$LauncherSize" -PropertyType "DWord" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "NoModify" -Value "1" -PropertyType "DWord" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Name "NoRepair" -Value "1" -PropertyType "DWord" -Force | Out-Null
    
        # Modify Regisry Values [Renegade X Game Executable]
        if ($FileData.Enhancements.UpdateExecutable -Match "Enable") {
        
            if (Test-Path "$ProgramRoot\Source\Binaries\InstallInfo.xml") {
                [XML]$FilePath = Get-Content "$ProgramRoot\Source\Binaries\InstallInfo.xml"
                $RegistryKey = "UDK" + "-" + $FilePath.InstallInfo.InstallGuidString
            }
            
            if (!(Test-Path Variable:RegistryKey)) {
                $RegistryKey = "Renegade X Game Executable ($env:Username)"
            }
        
            if (Test-Path "$ProgramRoot\Source\UDKGame\Config\DefaultRenegadeX.ini") {
                $ExecutableVersion = Get-Content "$ProgramRoot\Source\UDKGame\Config\DefaultRenegadeX.ini" | Where-Object { $_ -Match "GameVersion=" }
                $ExecutableVersion = $ExecutableVersion.Split("=")[1]
                $ExecutableVersion = if ("$ExecutableVersion" -Match "\d+(\.\d+)+") { $Matches[0] }
            }
            
            if (!(Test-Path Variable:ExecutableVersion)) {
                $ExecutableVersion = "5.470"
            }
            
            if (!(Test-Path "$ProgramRoot\Source\Launcher")) {
                $ExecutableSize = ((Get-ChildItem "$ProgramRoot\Source" -Recurse | Measure-Object -Property Length -Sum | Select -ExpandProperty "Sum")/1024)
                $ExecutableSize = ($ExecutableSize - $LauncherSize)
            }
            
            if (!(Test-Path Variable:ExecutableSize)) {
                $ExecutableSize = "10485760"
            }
            
            if (Test-Path "$ProgramRoot\Source\Binaries\InstallData\Uninstall.ico") {
                $ExecutableIcon = "$ProgramRoot\Source\Binaries\InstallData\Uninstall.ico"
            }
            
            if (!(Test-Path Variable:ExecutableIcon)) {
                $ExecutableIcon = "$ProgramRoot\Files\Icon Database\Renegade X - Setup.ico"
            }
            
        }
    
        # Delete Registry Profile [Renegade X Game Executable]
        if (Test-Path "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Game Executable ($env:Username)") {
            Remove-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Game Executable ($env:Username)" -Force -Recurse
        }
    
        # Delete Registry Profile [Modified Renegade X Game Executable]
        if (Test-Path "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey") {
            Remove-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Force -Recurse
        }
        
        # Install Registry Profile [Renegade X Game Executable]
        New-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall" -Name "$RegistryKey" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "DisplayName" -Value "Renegade X Game Executable" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "DisplayIcon" -Value "$ExecutableIcon" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "DisplayVersion" -Value "$ExecutableVersion" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "Publisher" -Value "$env:Username" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "InstallLocation" -Value "$ProgramRoot\Source" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "UninstallString" -Value "$ProgramRoot\Source\Binaries\UnSetup.exe /uninstall" -PropertyType "String" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "EstimatedSize" -Value "$ExecutableSize" -PropertyType "DWord" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "NoModify" -Value "1" -PropertyType "DWord" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "NoRepair" -Value "1" -PropertyType "DWord" -Force | Out-Null
        New-ItemProperty Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Name "EULAAccepted" -Value "1" -PropertyType "DWord" -Force | Out-Null
        
    }
    
    # Setup Shortcut
    if ($ShortcutMode -Match "Enable") {
        
        # Shell COM Object
        $Shell = New-Object -ComObject ("WScript.Shell")
        
        # Shortcut Variables
        $ShortcutPath = "$env:UserProfile\Desktop\Renegade X.lnk"
        $TargetPath = "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe"
        $Arguments = ""
        $WorkingDirectory = ""
        $IconLocation = "$ProgramRoot\Files\Icon Database\Renegade X - Setup.ico"
        $IconArrayIndex = "0"
        $Description = ""
        $WindowStyle = ""
        $Hotkey = ""
        
        # Remove Previous Shortcut
        Remove-Item "$ShortcutPath" -Force
        
        # Create Shortcut
        $Shortcut = $Shell.CreateShortcut($ShortcutPath)
        $Shortcut.TargetPath = $TargetPath
        $Shortcut.Arguments = $Arguments
        $Shortcut.WorkingDirectory = $WorkingDirectory
        $Shortcut.IconLocation = $IconLocation + ", " + $IconArrayIndex
        $Shortcut.Description = $Description
        $Shortcut.WindowStyle = $WindowStyle
        $Shortcut.Hotkey = $Hotkey
        $Shortcut.Save()
    
    }

    # Setup Firewall
    if ($FirewallMode -Match "Enable") {
    
        # Install Firewall Profile [Renegade X Launcher]
        New-NetFirewallRule -Direction "Inbound" -DisplayName "Renegade X Launcher" -Program "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe" -Profile @("Domain", "Private", "Public") -Protocol "Any" -Enable "True" -Action "Allow" | Out-Null
        New-NetFirewallRule -Direction "Outbound" -DisplayName "Renegade X Launcher" -Program "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe" -Profile @("Domain", "Private", "Public") -Protocol "Any" -Enable "True" -Action "Allow" | Out-Null
    
        # Install Firewall Profile [Renegade X Game Executable (x32)]
        New-NetFirewallRule -Direction "Inbound" -DisplayName "Renegade X Game Executable (x32)" -Program "$ProgramRoot\Source\Binaries\Win32\UDK.exe" -Profile @("Domain", "Private", "Public") -Protocol "Any" -Enable "True" -Action "Allow" | Out-Null
        New-NetFirewallRule -Direction "Outbound" -DisplayName "Renegade X Game Executable (x32)" -Program "$ProgramRoot\Source\Binaries\Win32\UDK.exe" -Profile @("Domain", "Private", "Public") -Protocol "Any" -Enable "True" -Action "Allow" | Out-Null
    
        # Install Firewall Profile [Renegade X Game Executable (x64)]
        New-NetFirewallRule -Direction "Inbound" -DisplayName "Renegade X Game Executable (x64)" -Program "$ProgramRoot\Source\Binaries\Win64\UDK.exe" -Profile @("Domain", "Private", "Public") -Protocol "Any" -Enable "True" -Action "Allow" | Out-Null
        New-NetFirewallRule -Direction "Outbound" -DisplayName "Renegade X Game Executable (x64)" -Program "$ProgramRoot\Source\Binaries\Win64\UDK.exe" -Profile @("Domain", "Private", "Public") -Protocol "Any" -Enable "True" -Action "Allow" | Out-Null
        
    }

    # Program Setup
    $ToggleSwitch = $true
    if ($ToggleSwitch -EQ $true) {
    
        # Remove File(s)
        if (Test-Path (Get-ChildItem "$ProgramRoot\Source\Binaries\*" -File -Recurse | Where-Object {($_.Name -NotMatch "Empty")})) {
            Get-ChildItem "$ProgramRoot\Source\Binaries" -File | Where-Object {($_.Name -EQ "Empty") -And (-Not $_.Extension) -And (-Not $_.PsIsContainer)} | Remove-Item -Force
        }
        if (Test-Path (Get-ChildItem "$ProgramRoot\Source\Engine\*" -File -Recurse | Where-Object {($_.Name -NotMatch "Empty")})) {
            Get-ChildItem "$ProgramRoot\Source\Engine" -File | Where-Object {($_.Name -EQ "Empty") -And (-Not $_.Extension) -And (-Not $_.PsIsContainer)} | Remove-Item -Force
        }
        if (Test-Path (Get-ChildItem "$ProgramRoot\Source\UDKGame\*" -File -Recurse | Where-Object {($_.Name -NotMatch "Empty")})) {
            Get-ChildItem "$ProgramRoot\Source\UDKGame" -File | Where-Object {($_.Name -EQ "Empty") -And (-Not $_.Extension) -And (-Not $_.PsIsContainer)} | Remove-Item -Force
        }
    
        # Create Configuration Folder(s)
        if (!(Test-Path "$ProgramRoot\Source\Launcher")) {
            New-Item -Path "$ProgramRoot\Source" -Name "Launcher" -ItemType "Directory"
        }
        if (!(Test-Path "$ProgramRoot\Source\UDKGame\Config")) {
            New-Item -Path "$ProgramRoot\Source\UDKGame" -Name "Config" -ItemType "Directory"
        }
    
        # Backup Configuration File(s)
        Rename-Item "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe.config" "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe.config.bak"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKEngine.ini" "$ProgramRoot\Source\UDKGame\Config\UDKEngine.ini.bak"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKGame.ini" "$ProgramRoot\Source\UDKGame\Config\UDKGame.ini.bak"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKInput.ini" "$ProgramRoot\Source\UDKGame\Config\UDKInput.ini.bak"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKPlayerMonitor.ini" "$ProgramRoot\Source\UDKGame\Config\UDKPlayerMonitor.ini.bak"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKRenegadeX.ini" "$ProgramRoot\Source\UDKGame\Config\UDKRenegadeX.ini.bak"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKSystemSettings.ini" "$ProgramRoot\Source\UDKGame\Config\UDKSystemSettings.ini.bak"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKXSettings.ini" "$ProgramRoot\Source\UDKGame\Config\UDKXSettings.ini.bak"
    
        # Duplicate Configuration File(s)
        Copy-Item "$ProgramRoot\Files\Configuration\Renegade X Launcher.exe.config" "$ProgramRoot\Source\Launcher" -Force
        Copy-Item "$ProgramRoot\Files\Configuration\UDKEngine.ini" "$ProgramRoot\Source\UDKGame\Config" -Force
        Copy-Item "$ProgramRoot\Files\Configuration\UDKGame.ini" "$ProgramRoot\Source\UDKGame\Config" -Force
        Copy-Item "$ProgramRoot\Files\Configuration\UDKInput.ini" "$ProgramRoot\Source\UDKGame\Config" -Force
        Copy-Item "$ProgramRoot\Files\Configuration\UDKPlayerMonitor.ini" "$ProgramRoot\Source\UDKGame\Config" -Force
        Copy-Item "$ProgramRoot\Files\Configuration\UDKRenegadeX.ini" "$ProgramRoot\Source\UDKGame\Config" -Force
        Copy-Item "$ProgramRoot\Files\Configuration\UDKSystemSettings.ini" "$ProgramRoot\Source\UDKGame\Config" -Force
        Copy-Item "$ProgramRoot\Files\Configuration\UDKXSettings.ini" "$ProgramRoot\Source\UDKGame\Config" -Force
    
    }
    
}

if ($ExecutableMode -EQ "Remove") {

    # Remove Registry [Renegade X Launcher]
    if ($RegistryMode -Match "Enable") {
    
        # Delete Registry Profile [Renegade X Launcher]
        Remove-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Launcher ($env:Username)" -Force -Recurse
    
        # Delete Registry Profile [Renegade X Game Executable]
        Remove-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Renegade X Game Executable ($env:Username)" -Force -Recurse
  
        # Delete Registry Profile [Modified Renegade X Game Executable]
        if (Test-Path "$ProgramRoot\Source\Binaries\InstallInfo.xml") {
            [XML]$FilePath = Get-Content "$ProgramRoot\Source\Binaries\InstallInfo.xml"
            $RegistryKey = "UDK" + "-" + $FilePath.InstallInfo.InstallGuidString
            Remove-Item Registry::"HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$RegistryKey" -Force -Recurse
        }
        
    }
    
    # Remove Shortcut
    if ($ShortcutMode -Match "Enable") {
    
        # Delete Shortcut [Renegade X]
        Remove-Item "$env:UserProfile\Desktop\Renegade X.lnk" -Force
        
    }
    
    # Remove Firewall
    if ($FirewallMode -Match "Enable") {
    
        # Delete Firewall Profile [Renegade X Launcher]
        Get-NetFirewallApplicationFilter -Program "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe" | Remove-NetFirewallRule
    
        # Delete Firewall Profile [Renegade X Game Executable (x32)]
        Get-NetFirewallApplicationFilter -Program "$ProgramRoot\Source\Binaries\Win32\UDK.exe" | Remove-NetFirewallRule
    
        # Delete Firewall Profile [Renegade X Game Executable (x64)]
        Get-NetFirewallApplicationFilter -Program "$ProgramRoot\Source\Binaries\Win64\UDK.exe" | Remove-NetFirewallRule
        
    }

    # Program Removal
    $ToggleSwitch = $true
    if ($ToggleSwitch -EQ $true) {
    
        # Remove Configuration File(s)
        Remove-Item "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe.config" -Force
        Remove-Item "$ProgramRoot\Source\UDKGame\Config\UDKEngine.ini" -Force
        Remove-Item "$ProgramRoot\Source\UDKGame\Config\UDKGame.ini" -Force
        Remove-Item "$ProgramRoot\Source\UDKGame\Config\UDKInput.ini" -Force
        Remove-Item "$ProgramRoot\Source\UDKGame\Config\UDKPlayerMonitor.ini" -Force
        Remove-Item "$ProgramRoot\Source\UDKGame\Config\UDKRenegadeX.ini" -Force
        Remove-Item "$ProgramRoot\Source\UDKGame\Config\UDKSystemSettings.ini" -Force
        Remove-Item "$ProgramRoot\Source\UDKGame\Config\UDKXSettings.ini" -Force
    
        # Restore Configuration File(s)
        Rename-Item "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe.config.bak" "$ProgramRoot\Source\Launcher\Renegade X Launcher.exe.config"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKEngine.ini.bak" "$ProgramRoot\Source\UDKGame\Config\UDKEngine.ini"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKGame.ini.bak" "$ProgramRoot\Source\UDKGame\Config\UDKGame.ini"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKInput.ini.bak" "$ProgramRoot\Source\UDKGame\Config\UDKInput.ini"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKPlayerMonitor.ini.bak" "$ProgramRoot\Source\UDKGame\Config\UDKPlayerMonitor.ini"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKRenegadeX.ini.bak" "$ProgramRoot\Source\UDKGame\Config\UDKRenegadeX.ini"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKSystemSettings.ini.bak" "$ProgramRoot\Source\UDKGame\Config\UDKSystemSettings.ini"
        Rename-Item "$ProgramRoot\Source\UDKGame\Config\UDKXSettings.ini.bak" "$ProgramRoot\Source\UDKGame\Config\UDKXSettings.ini"
    
    }

}

# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Finished Extension.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}