﻿# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Loading Initalise.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}

# Program Directory - Set Variables [General]
$Global:ProgramRoot = [Environment]::CurrentDirectory
$Global:ProgramHost = Split-Path -Parent $ProgramRoot
$Global:ProgramName = Split-Path -Leaf $ProgramRoot

# Program Directory - Set Variables [ProgramVersion]
if ($ProgramName -Like "*$Versioning*") {
    $Global:ProgramVersion = ($ProgramName) -Replace ".* $Versioning "
} else {
    $Global:ProgramVersion = "Error"
}

# Console Information
if ($VerboseMode -EQ $true) {
    Write-Host "Program Variables"
    Write-Host "• Program Root: $ProgramRoot"
    Write-Host "• Program Host: $ProgramHost"
    Write-Host "• Program Name: $ProgramName"
    Write-Host ""
}

# Running Directory - Set Variables [General]
$Global:RunningRoot = $MyInvocation.MyCommand.Path
$Global:RunningHost = Split-Path -Parent $RunningRoot
$Global:RunningName = Split-Path -Leaf $RunningRoot

# Console Information
if ($VerboseMode -EQ $true) {
    Write-Host "Running Variables"
    Write-Host "• Running Root: $RunningRoot"
    Write-Host "• Running Host: $RunningHost"
    Write-Host "• Running Name: $RunningName"
    Write-Host ""
}

# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Finished Initalise.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}