﻿# Toggle Information
$Global:DebugMode = $false
$Global:VerboseMode = $false

# PowerShell Preferences
$Global:ExecutableMode = "Remove"
$Global:ErrorActionPreference = "SilentlyContinue"
$Global:OutputEncoding = [Console]::InputEncoding = [Console]::OutputEncoding = New-Object System.Text.UTF8Encoding
$Global:ExecutionPolicy = Get-ExecutionPolicy -Scope LocalMachine
Set-ExecutionPolicy -ExecutionPolicy Bypass -Scope LocalMachine -Force

# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Loading Remove.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}

# Initalise Removal
& ".\Files\Script Database\Console.ps1"
& ".\Files\Script Database\Configure.ps1"
& ".\Files\Script Database\Initalise.ps1"
& ".\Files\Script Database\Terminate.ps1"

# Load Resources
& ".\Files\Script Database\$ModuleFile"

# Finalise Removal
& ".\Files\Script Database\Registry.ps1"
& ".\Files\Script Database\Shortcut.ps1"
& ".\Files\Script Database\Destruct.ps1"

# Restore Execution Policy
Set-ExecutionPolicy -ExecutionPolicy $ExecutionPolicy -Scope LocalMachine -Force

# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Finished Remove.ps1"
    Write-Host "• Press [Enter] to exit."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}

# Invisibility
CLS | Out-Null

# Play Removal Sound
$Sound = New-Object System.Media.SoundPlayer
$Sound.SoundLocation = "$env:WinDir\Media\Windows Foreground.wav"
$Sound.Play()

# Prevent Sound Interrupt
Start-Sleep -Milliseconds 2500

# Quit PowerShell
Stop-Process -ID $PID