﻿# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Loading Terminate.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}

# Execute Setup Instructions
if ($ExecutableMode -EQ "Setup") {

    # Close Program(s) - Detect Open Process(es)
    if ($TerminateMode -Match "Enable") {
        Get-Process | Where-Object {($_.Path -Like "*" + [Environment]::CurrentDirectory + "*") -AND ($_.Description -NE "Program Setup Launcher") -AND ($_.Description -NE "Program Removal Launcher") -AND ($_.ID -NE $PID)} | Stop-Process -Force
    }
    
    # Close Program(s) - Close Known Process(ss)
    if ($ProcessesList -NE "Error") {
        Get-Process | Where-Object {($_.ProcessName -Match $ProcessesList) -AND ($_.ID -NE $PID)} | Stop-Process -Force
    }
    
    # Close Program(s) - Force Shutdown
    if ($ShutdownMode -Match "Enable") {
    
        # Close Windows Explorer
        (New-Object -ComObject Shell.Application).Windows() | ForEach-Object {$_.Quit()}
    
        # Close Process(es)
        Get-Process | Where-Object {($_.MainWindowTitle -NE "") -AND ($_.ID -NE $PID)} | Stop-Process -Force
    
    }

}

# Execute Removal Instructions
if ($ExecutableMode -EQ "Remove") {

    # Close Program(s) - Detect Open Process(es)
    if ($TerminateMode -Match "Enable") {
        Get-Process | Where-Object {($_.Path -Like "*" + [Environment]::CurrentDirectory + "*") -AND ($_.Description -NE "Program Setup Launcher") -AND ($_.Description -NE "Program Removal Launcher") -AND ($_.ID -NE $PID)} | Stop-Process -Force
    }
    
    # Close Program(s) - Close Known Process(ss)
    if ($ProcessesList -NE "Error") {
        Get-Process | Where-Object {($_.ProcessName -Match $ProcessesList) -AND ($_.ID -NE $PID)} | Stop-Process -Force
    }
    
    # Close Program(s) - Force Shutdown
    if ($ShutdownMode -Match "Enable") {
    
        # Close Windows Explorer
        (New-Object -ComObject Shell.Application).Windows() | ForEach-Object {$_.Quit()}
    
        # Close Process(es)
        Get-Process | Where-Object {($_.MainWindowTitle -NE "") -AND ($_.ID -NE $PID)} | Stop-Process -Force
    
    }

    # Run Destruction Procedures
    if ($DestructMode -Match "Enable") {
    
        # Close Windows Explorer - Default Varient
        if (!([Environment]::CurrentDirectory -Like "*×*")) {
            $Shell = New-Object -ComObject Shell.Application
            $Window = $Shell.Windows() | Where-Object { $_.LocationURL -Match "$(([URI][Environment]::CurrentDirectory).AbsoluteUri)" }
            $Window | ForEach-Object { $_.Quit() }
        }
    
        # Close Windows Explorer - Version Varient
        if ([Environment]::CurrentDirectory -Like "*×*") {
            $Shell = New-Object -ComObject Shell.Application
            $env:CurrentDirectory = ([Environment]::CurrentDirectory) -Replace " × .*"
            $Window = $Shell.Windows() | Where-Object { $_.LocationURL -Match "$(([URI]$env:CurrentDirectory).AbsoluteUri)" }
            $Window | ForEach-Object { $_.Quit() }
        }
    
    }

}

# Console Information
if ($DebugMode -EQ $true) {
    Write-Host "Finished Terminate.ps1"
    Write-Host "• Press [Enter] to continue."
    $Host.UI.RawUI.ReadKey('NoEcho,IncludeKeyDown') | Out-Null
    Write-Host ""
}